/*******************************************************************
 * fW^}`[^
 *   PIC24FV32KA301 + MCP3422
 * @ADCœdƓdv
 * @CTMUŃRfTeʌv
 * @ADCŒRlv
 *   Raspberry PĩR}hɉČvlԑ
 *******************************************************************/
#include <xc.h>
#include <math.h>
#include <p24FV32KA302.h>
#include "lcd_i2c_lib24.h"
/* RtBM[V̐ݒ */
// PIC24FV32KA302 Configuration Bit Settings
// FBS
#pragma config BWRP = OFF               // Boot Segment Write Protect (Disabled)
#pragma config BSS = OFF                // Boot segment Protect (No boot program flash segment)
// FGS
#pragma config GWRP = OFF               // General Segment Write Protect (General segment may be written)
#pragma config GSS0 = OFF               // General Segment Code Protect (No Protection)
// FOSCSEL
#pragma config FNOSC = PRIPLL           // Oscillator Select (Primary oscillator with PLL Module (HS+PLL, EC+PLL))
#pragma config SOSCSRC = DIG            // SOSC Source Type (Digital Mode for use with external source)
#pragma config LPRCSEL = HP             // LPRC Oscillator Power and Accuracy (High Power, High Accuracy Mode)
#pragma config IESO = OFF               // Internal External Switch Over bit (Internal External Switchover mode disabled (Two-speed Start-up disabled))
// FOSC
#pragma config POSCMOD = HS             // Primary Oscillator Configuration bits (HS oscillator mode selected)
#pragma config OSCIOFNC = OFF           // CLKO Enable Configuration bit (CLKO output disabled)
#pragma config POSCFREQ = HS            // Primary Oscillator Frequency Range Configuration bits (Primary oscillator/external clock input frequency greater than 8MHz)
#pragma config SOSCSEL = SOSCLP         // SOSC Power Selection Configuration bits (Secondary Oscillator configured for low-power operation)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Both Clock Switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscale Select bits (1:32768)
#pragma config FWPSA = PR128            // WDT Prescaler bit (WDT prescaler ratio of 1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT disabled in hardware; SWDTEN bit disabled)
#pragma config WINDIS = OFF             // Windowed Watchdog Timer Disable bit (Standard WDT selected(windowed WDT disabled))
// FPOR
#pragma config BOREN = BOR3             // Brown-out Reset Enable bits (Brown-out Reset enabled in hardware, SBOREN bit disabled)
#pragma config LVRCFG = ON              // Low Voltage Regulator Configuration bit (Low Voltage regulator is available and controlled by LVREN bit)
#pragma config PWRTEN = ON              // Power-up Timer Enable bit (PWRT enabled)
#pragma config I2C1SEL = SEC            // Alternate I2C1 Pin Mapping bit (Use  Alternate SCL1/ASDA1 Pins For I2C1)
#pragma config BORV = V20               // Brown-out Reset Voltage bits (Brown-out Reset set to lowest voltage (2.0V))
#pragma config MCLRE = ON               // MCLR Pin Enable bit (RA5 input pin disabled,MCLR pin enabled)
// FICD
#pragma config ICS = PGx1               // ICD Pin Placement Select bits (EMUC/EMUD share PGC1/PGD1)
// FDS
#pragma config DSWDTPS = DSWDTPSF       // Deep Sleep Watchdog Timer Postscale Select bits (1:2,147,483,648 (25.7 Days))
#pragma config DSWDTOSC = LPRC          // DSWDT Reference Clock Select bit (DSWDT uses Low Power RC Oscillator (LPRC))
#pragma config DSBOREN = OFF            // Deep Sleep Zero-Power BOR Enable bit (Deep Sleep BOR disabled in Deep Sleep)
#pragma config DSWDTEN = OFF            // Deep Sleep Watchdog Timer Enable bit (DSWDT disabled)

/* O[oϐA萔` */
int i, Index;
unsigned char Result[5];
unsigned char State, Flag, Range, CRSW, Loop, fFlag, rFlag;
unsigned long Freq, OverFreq;
float Volt, Current, RegisterM, RegisterK, Capacitor, Offset, vReference, Mesure;
char RcvBuf[32];
char SendBuf[64];
union{                                  // ϐϊp̃jI///
	signed long lData;
	unsigned char cData[4];
}DataArray;
/* \bZ[W */
const char StatMsg[] 	= "Start DMM!      ";
const char SWMsg[]      = "Now Calibrating ";
const char OvrMsg1[]    = "Range Over 1MOhm";
const char OvrMsg2[]    = "Range Over10KOhm";
const char OvrMsg3[]    = "Range Over 1uF  "; 
const char ChgMsg[]     = "Switch to 1/10  ";
/* f[^\pσobt@ */
char Line1[] = "+xx.xxxV x.xxxxA";
char Line2[] = "Cap xxxx   pF   ";      // RfTe
char Line3[] = "Cap x.xxx  uF   ";
char Line4[] = "Res xxxx.x KOhm ";      // Rl@1Mx[X
char Line5[] = "Res xxxxx Ohm   ";      // Rl@10kx[X
char Line6[] = "Freq xxxxxxxx Hz";      // gJE^p
/* ֐vg^CsO */
void Init(void);
void CmdI2C(unsigned char data);
void GetDataI2C(unsigned char *Buffer, unsigned char CNT);
void DataTrans(unsigned char sData);
int CTMUCap(int current, int chan);
void Delay10(unsigned int t);
int Resist(int chan);
void itostring(char digit, unsigned int data, char *buffer);
void ftostring(int seisu, int shousu, float data, char *buffer);
void ltostring(char digit, unsigned long data, char *buffer);
float GetCapacitor(unsigned char level);
void DispCap(void);
void Send(char Data);
void SendStr(char *str);

/*********** C֐ **************************/
int main(void){
    /* NbN̐ݒ@32MHz */
    CLKDIV = 0;
    /* I/Ȍݒ */
    LATAbits.LATA7 = 0;                 //LED
    LATBbits.LATB0 = 1;                 // TX High
    TRISA = 0x002F;                     // 
    TRISB = 0xF3EE;                     //
    /* AiOsݒ */
    ANSA = 0x0002;                      //
    ANSB = 0xF00C;                      //
    /* XCb`֘Aݒ */
    CNEN1bits.CN2IE = 1;                // RA0 CN2 enable   
    /* 12bitADCݒ */
    AD1CON1 = 0;                        // All Clear
    AD1CON2 = 0;
    AD1CON3 = 0;
    AD1CON5 = 0;
    AD1CSSH = 0;
    AD1CSSL = 0;
    AD1CON1bits.MODE12 = 1;             // 12bit mode
    AD1CON1bits.FORM = 0;               // El
    AD1CON1bits.SSRC = 0;               // Manual Start
    AD1CON1bits.ASAM = 1;               // Auto sample
    AD1CON2bits.PVCFG = 2;              // VBGx2 = 2.048V
    AD1CON2bits.NVCFG = 0;              // VSS
    AD1CON3bits.SAMC = 2;               // 3Tad
    AD1CON3bits.ADCS = 4;               // 1usec
    AD1CON5bits.BGREQ = 1;              // Enable BandGap  
    AD1CON1bits.ADON = 1;
    /* CTMUݒ */
    CTMUCON1 = 0;                       // No edge trigger
    CTMUCON2 = 0;                       // No trigger
    CTMUICON = 0;                       // Normal current
    CTMUICONbits.IRNG = 1;              // 0.55uA
    CTMUCON1bits.CTMUEN = 1;            // CTMU Enable
    /* I2C̏ݒ */
    I2C1BRG = 0x9D;                     // 100kHz@16MHz
    I2C1CONbits.I2CEN = 1;              // I2CCl[u
    /* OC1 32bit mode setting */
    OC1CON2bits.OC32 = 1;               // 32bit mode    
    OC1CON1bits.OCTSEL = 7;             // Fcy=16MHz
    OC1CON2bits.SYNCSEL = 0x1F;         // Self Out
    OC1CON2bits.OCTRIG = 0;             // No
    OC1CON2bits.OCTRIS = 1;             // No output
    OC1R = 0x1200;                      // 1sec
    OC1RS = 0x1200; 
    /* OC2 32bit mode setting */   
    OC2CON2bits.OC32 = 1;               // 32bit mode    
    OC2CON2bits.SYNCSEL = 0x1F;         // Self Out    
    OC2CON2bits.OCTRIS = 0;             // Output Enable to RB11
    OC2R = 0x7A;                        // 1sec
    OC2RS = 0x7A;
    /* OC2 荞݋AX^[g */
    IPC1bits.OC2IP = 5;                 // OC2荞݃x
    IFS0bits.OC2IF = 0;
    IEC0bits.OC2IE = 1;
    OC1CON1bits.OCM = 7;                // Center Align PWM Mode  
    OC2CON1bits.OCM = 7;                // Center Align PWM Mode
    /* ^C}Pݒ@񓯊JE^ */
    T1CON = 0x0102;                     // T1CK No Sync
    IPC0bits.T1IP = 4;                  // 荞݃x
    IFS0bits.T1IF = 0;
    IEC0bits.T1IE = 1;                  // ^C}1荞݋   
    /* UART2ݒ@115kbps  */
    U2MODE = 0x8808;                    // UART1ݒ BRGH=1
    U2STA =  0x0400;                    // UART1ݒ
    U2BRG = 34;                         // 115kbps@32MHz
    IPC7bits.U2RXIP = 4;                // UART1荞݃x
    IFS1bits.U2RXIF = 0;                // 荞݃tONA
    IEC1bits.U2RXIE = 1;                // UART1M荞݋    
    /*ԕω荞݋*/
    IPC4bits.CNIP = 2;                  // IOC荞݃x
    IFS1bits.CNIF = 0;                  // tONA
    IEC1bits.CNIE = 1;                  // 荞݋
    /* t\평 */
    lcd_init();                         // 
    lcd_clear();                        // S
    lcd_cmd(0x80);                      // 1sڎw
    lcd_str((char*)StatMsg);            // Jn\
    lcd_cmd(0xC0);
    lcd_str((char*)SWMsg);              // ItZbg\
    lcd_icon(12, 0);
    lcd_icon(9, 0);    
    /* eʑItZbg擾 */
    Offset = GetCapacitor(1);           // lItZbgɂ 
    CRSW = 1;
    /********************* C[v ********************/
    while(1){
        lcd_icon(2, (Loop ^= 1));                            // ڈACR\
        /***** dƓďv̏ꍇi0.5bԊujXe[g֐j  ******/
        switch(State){
            case 0:
                CmdI2C(0x8C);                               // AD@CH1 ϊJn
                State = 1;                                  // ̃Xe[g
                break;          
            case 1:
                /* ďvƕ\ 18bit */   
                /* 2.048V17bit\ = 2.048V/131071=15.625uV */                
                GetDataI2C(Result, 3);                      // f[^擾 3oCg//
                DataArray.lData = 0;                        // ϐGA//
                for(i=0; i<3; i++)                          // Mf[^𐔒l֕ϊ//
                    DataArray.cData[2-i] = Result[i];
                if((DataArray.cData[2] & 0x80)!= 0){        // ̒lH//
                    DataArray.cData[3] = 0xFF;              // ŏʃoCg//
                    DataArray.lData = ~DataArray.lData + 1; // ̒lɕϊ//
                    Flag = '-';
                }
                else
                    Flag = ' ';                             // ̕\Zbg
                /* ɕϊ@}xx.xxxV  */
                Volt = (11.0 * 2.048 * (float)DataArray.lData)/0x1FFFF;
                ftostring(2, 3, Volt, Line1+1);             // ɕϊ//
                Line1[0] = Flag;
                lcd_cmd(0x80);                              // 1sڂɕ\
                lcd_str((char*)Line1);
                State = 2;                                  // ̃Xe[g
                break;
            case 2:
                CmdI2C(0xAC);                               // AD@CH2 ϊJn
                State = 3;                                  // ̃Xe[g
                break;
            case 3:
                /* ďvƕ\ */ 
                /* 2.048A/131071=15.625uA Step */
                GetDataI2C(Result, 3);                      // f[^擾 3oCg//
                DataArray.lData = 0;                        // ϐGA//
                for(i=0; i<3; i++)                          // Mf[^𐔒l֕ϊ//
                    DataArray.cData[2-i] = Result[i];       // 1P^o
                if((DataArray.cData[2] & 0x80)!= 0){        // ̒l̏ꍇ
                    DataArray.cData[3] = 0xFF;              // ŏʃoCg//
                    DataArray.lData = ~DataArray.lData + 1; // ̒lɕϊ//
                }
                /* ɕϊ@x.xxxxA */
                Current = (2.0480 * (float)DataArray.lData)/0x1FFFF;
                ftostring(1, 4, Current, Line1+9);          // ɕϊ//
                lcd_cmd(0x80);                              // 1sڂɕ\
                lcd_str((char*)Line1);
                State = 0;                                  // ŏ̃Xe[gɖ߂ČJԂ                
                break;
            default:
                break;
        }
        /********* RfTeʂRlvgJE^̏ꍇ ****************/
        /*** RfTeʂ̑ **/
        /* W̎mF */ 
        Range = 4;                                          // WlZbg
        do{
            Range--;                                        // ̃W 
            Mesure = (float)CTMUCap(Range, 11);             // 푪RfT AN11     
        }while((Mesure > 4000.0)&&(Range > 0));
        /* eʒl̑ */
        Capacitor = GetCapacitor(Range)- Offset;            // eʒl̑s 
        /*** 1MohmW̒R ****/
        /* ďv */
        vReference = 0;
        for(i=0; i<30; i++)                                 // 30񕽋
            vReference += 2 * (float)Resist(12);            // d AN12
        /* 푪Rlv */
        Mesure = 0;                                         // ϘaZbg
        for(i=0; i<30; i++)                                 // 30񕽋
            Mesure += (float)Resist(10);                    // 肵a AN10
        RegisterM = (1000.0*Mesure)/(vReference-Mesure);    // RlɊZ
        /*** 10kohmW̒R ****/ 
        /* 푪Rlv  */          
        Mesure = 0;                                         // ϘaZbg
        for(i=0; i<30; i++)                                 // 30񕽋
            Mesure += (float)Resist(9);                     // 푪dv AN9
        RegisterK = (10000.0*Mesure)/(vReference-Mesure);   // Rlɕϊ 
        
        /***** vl̉t\ iꂩ1ڂ̂ݕ\) **********/
        switch(CRSW){
            /* RfTeʑ̏ꍇ */        
            case 1:
                /* eʒl\s */
                DispCap();
                break;
            /***** Rl̏ꍇ ******/
            case 2:     /** 1M̌v Mesure=(Reference*Rx)/(Rx+1M)**/
                if(RegisterM < 1500){                       // 1.5Mȉ̏ꍇ
                    ftostring(4, 1, RegisterM, Line4 + 4);  // xxxx.x̕ɕϊ
                    lcd_cmd(0xC0);                          // 2sڂɕ\
                    lcd_str((char*)Line4);
                }
                else{                                       // 15Mȏ̏ꍇ
                    lcd_cmd(0xC0);
                    lcd_str((char*)OvrMsg1);                // WI[o[\
                }
                break;
            case 3:     /** 10k̌v Mesure=(Reference*Rx)/(Rx+10k)**/ 
                if(RegisterK < 15000){                      // 15kȉ̏ꍇ
                    ftostring(5, 0, RegisterK, Line5 + 4);  // 5̐ɕϊ
                    lcd_cmd(0xC0);                          // 2sڂɕ\
                    lcd_str((char*)Line5);
                }
                else{                                       // 15kȏ̏ꍇ
                    lcd_cmd(0xC0);
                    lcd_str((char*)OvrMsg2);                // WI[o[\
                }
                break;
            case 4:     /* gJE^̏ꍇ */
                if(fFlag == 1){                             // JEgȈꍇ
                    ltostring(8, Freq, Line6+5);            // ɕϊ
                    lcd_cmd(0xC0);                          // 2sڎw
                    lcd_str(Line6);                         // \o
                }
        } 
        /****** RaspberrỹR}hM ********/
        if(rFlag){                                          // UARTMtOȈꍇ
            rFlag = 0;
            LATAbits.LATA7 ^= 1;                    // ڈ  
            if(RcvBuf[0] == 'M'){
                for(i=0; i<64; i++)
                    SendBuf[i] = ' ';
                switch(RcvBuf[1]){              
                    case 'R':      //  Request                      
                        SendBuf[0] = 'D';
                        ftostring(2, 3, Volt, SendBuf+1);       // d
                        SendBuf[8] = ',';
                        ftostring(1, 4, Current, SendBuf+9);    // d
                        SendBuf[15] = ',';
                        ftostring(7, 0, Capacitor, SendBuf+16); // e
                        SendBuf[23] = ',';
                        ftostring(4, 1, RegisterM, SendBuf+24); // RMohm
                        SendBuf[30] = ',';
                        ftostring(5, 0, RegisterK, SendBuf+31); // RkOhm
                        SendBuf[36] = ',';
                        ltostring(8, Freq, SendBuf+37);
                        SendBuf[45] = '\r';
                        SendBuf[46] = '\n';
                        SendBuf[47] = 0;                        
                        SendStr(SendBuf);
                        break;
                    default:
                        break;
                }
            } 
        } 
        Delayms(300);                                           // Ŝ500msec        
    }
}
/**************************************************
 *@RfTeʌvTu֐
 *@WłƂɊRfTvRfT
 *@̗eʂ𑪒肵ŋ߂
 **************************************************/
float GetCapacitor(unsigned char level){
    float cReference, Sum, temp;
    /*** eʌvs ***/
    cReference = 0;                                      // ϘaNA
    Sum = 0;
    switch(level)
    {
        case 3:     // 0.01uF@to 1uF
            /* RfT0.1uFv */
            for(i=0; i<20; i++){                        // 20񕽋
                cReference += (float)CTMUCap(level, 1); // RfT  AN1               
            }
            /*@푪RfTv */
            for(i=0; i<20; i++)                         // 20񕽋
                Sum += (float)CTMUCap(level, 11);       // 푪RfTv AN11                    
            temp = (cReference * 100000) / Sum;         // eʒlɊZ@Wv
            break;
        case 2:     //@0.001uF to 0.01uF
            /* RfT0.01uFv */
            for(i=0; i<20; i++){                        // 20񕽋
                cReference += (float)CTMUCap(level, 4); // RfTv  AN4               
            }
            /*@푪RfTv */
            for(i=0; i<20; i++)                         // 20񕽋
                Sum += (float)CTMUCap(level, 11);       // 푪RfTv AN11                    
            temp = (cReference * 10000) / Sum;          // eʒlɊZ@Wv
            break; 
        case 1:     //  to 0.001uF
            /* RfT0.001uFv */
            for(i=0; i<20; i++){                        // 20񕽋
                cReference += (float)CTMUCap(level, 5); // RfTv  AN5               
            }
            /*@푪RfTv */
            for(i=0; i<20; i++)                         // 20񕽋
                Sum += (float)CTMUCap(level, 11);       // 푪RfTv AN11                    
            temp = (cReference * 1000) / Sum;           // eʒlɊZ@Wv
            break;                      
        default:                                        // ǂłȂꍇ
            break;
    }
    return(temp);
}
/*********************************************
 *  RfTeʒl̕\Tu֐
 *@ItZbgv̏ꍇƒʏv̏ꍇ
 *********************************************/
void DispCap(void){
    if(Capacitor < 0)                               //ɂȂ0ɐ
        Capacitor = 0;
    if(Capacitor <= 10000){                         // 10000pFȉ̏ꍇ
        ftostring(4, 0, Capacitor, Line2 +4);       // 4̐ɕϊ
        itostring(1, Range, Line2 + 15);            // pFPʂŕ\
        lcd_cmd(0xC0);                              // 2sڂɕ\
        lcd_str((char*)Line2);
    }
    else{                                           // 10000pFȏ̏ꍇ
        ftostring(1, 3, Capacitor/1000000, Line3+4);// x.xxxɕϊ
       itostring(1, Range, Line3 + 15);             // uFPʂŕ\
       lcd_cmd(0xC0);                               // 2sڂɕ\
       lcd_str((char*)Line3); 
    }
}
/*************************************************
 * RfTeʑ@CTMUTu֐
 *@d[d1msec[d~d
 *  current 00:550uA 01:0.55uA 10:5.5uA 11:55uA
 **************************************************/
int CTMUCap(int current, int chan){
    int time;

    switch(current){
        case 4: //gp
            CTMUICONbits.IRNG = 0;  // dl=x1000 
            time = 70;              // 7msec
            break;
        case 3:
            CTMUICONbits.IRNG = 3;  // dl=x100
            time = 200;             // 2msec
            break;
        case 2:
            CTMUICONbits.IRNG = 2;  // dl=x10
            time = 100;             // 1msec
            break;
        case 1:
            CTMUICONbits.IRNG = 1;  // dl=x1
            time = 40;              // 0.4msec
            break;
        default:
            break;
    }
    AD1CON1bits.ADON = 0;           // It
    AD1CON2bits.PVCFG = 0;          // t@XVddƂ
    AD1CHSbits.CH0SA = chan;        // `lI
    AD1CON1bits.ADON = 1;           // ADCėL
    CTMUICONbits.ITRIM = 0x22;      // CTMUdiȖځj
    /*@d **/
    CTMUCON1bits.IDISSEN = 1;       // dJn
    Delayms(10);                    // 10msec
    CTMUCON1bits.IDISSEN = 0;       // dI
    /* [d **/
    CTMUCON2bits.EDG1STAT = 1;      // [dJn
    Delay10(time);                  // 100usec~time
    CTMUCON2bits.EDG1STAT = 0;      // [dI
    /* Execute AD Conversion */
    IFS0bits.AD1IF = 0;
    AD1CON1bits.SAMP = 0;           // ϊJn
    while(IFS0bits.AD1IF == 0);     // ϊI҂
    return(ADC1BUF0);               // ϊʂԂ
}
/*************************************************
 * RTu֐
 **************************************************/
int Resist(int chan){
    /**  Execute AD Conversion */
    AD1CTMUENL = 0;
    AD1CON1bits.ADON = 0;
    AD1CON2bits.PVCFG = 2;
    AD1CHSbits.CH0SA = chan;        // `lI
    AD1CON1bits.ADON = 1;
    Delayms(1);
    IFS0bits.AD1IF = 0;
    AD1CON1bits.SAMP = 0;           // ϊJn
    while(IFS0bits.AD1IF == 0);     // ϊI҂
    return(ADC1BUF0);               // ϊʂԂ
}
/***********************************************
 * ԕω荞ݏ@vڐ؂ւ
 *@SW1
 *  CRSW 0= ItZbgv
 * @@@1= eʑ
 * @@@2= R10kȉ
 * @@@3= R1Mȉ
 ***********************************************/
void __attribute__((interrupt, no_auto_psv))  _CNInterrupt(void){
    /* SW1̏ꍇ */
    Delayms(30);
    if(PORTAbits.RA0 == 0){         // SW1̏ꍇ
        if(CRSW < 4)                // Xe[gXV
            CRSW++;
        else
            CRSW = 1;
    }
    while(PORTAbits.RA0 == 0);      // It܂ő҂
    Delayms(30);                    // `b^Opx
    IFS1bits.CNIF = 0;              // tONA
}
/****************************************************
 *  OC2荞ݏ@@1bԊuŊ荞
 *@gJE^̐
 *****************************************************/
void __attribute__((interrupt, no_auto_psv)) _OC2Interrupt(void){
    /* gJEgJnA~ */
    if(fFlag == 0){
        fFlag = 1;                          // JEgItO
        T1CONbits.TON = 0;                  // JEg~  
        Freq = TMR1 + (OverFreq * 65536);   // g߂  
        if(Freq != 0)                       // 0łȂꍇ
            Freq++;                         // +1JEg        
    }
    else{
        TMR1 = 0;                   // ^C}Zbg
        T1CONbits.TON = 1;          // JEgJn
        OverFreq = 0;
        fFlag = 0;                  // JEgtO          
    }
    IFS0bits.OC2IF = 0;
}
/***************************************
 * ^C}1荞ݏ֐
 ***************************************/
void __attribute__((interrupt, no_auto_psv)) _T1Interrupt(void){
    IFS0bits.T1IF = 0;
    OverFreq++;
}

/**********************************************************
* ADCRtBM[VݒTu֐(I2C)
*@Configuration
 * @RDY C1 C0 O S1 S0 G1 G0
 *     RDY  @: 1ŕϊJn
 * @@C1 C0@F `lI
 * @@O@@@F0=Aϊ@@1= Vbg
 * @@S1 S0@Frbgw@11=18bit@1016bit
 * @@G1 G0@FQCI @00=x1@01=x2@10=x4  11=x8
 *  @8C = CH0C18bitA x1AVbgŕϊJn
 *      AC = CH1A18bitAx1AVbgŕϊJn
**********************************************************/
void CmdI2C(unsigned char data)
{
    IdleI2C1();
    I2C1CONbits.SEN = 1;            // X^[go//
    while(I2C1CONbits.SEN);         // X^[gI҂//
    DataTrans(0xD0);                // AhXM
    DataTrans(data);                // R}hf[^M
    I2C1CONbits.PEN = 1;            // Xgbvo//
    while(I2C1CONbits.PEN);         // XgbvI҂//
}
/**********************************************
* ADCϊf[^擾Tu֐iI2Cp)
***********************************************/
void GetDataI2C(unsigned char *Buffer, unsigned char CNT)
{
    unsigned char i;
    IdleI2C1();                     // ACh҂
    I2C1STATbits.I2COV = 0;         // G[NA//
    I2C1CONbits.SEN = 1;            // X^[go//
    while(I2C1CONbits.SEN);         // X^[gI҂
    DataTrans(0xD1);                // AhXM Read[h
    for(i=0; i<CNT-1; i++) {        // oCgAM//
        I2C1CONbits.ACKDT = 0;      // ACKݒ//
        I2C1CONbits.RCEN = 1;       // M//
        while(I2C1CONbits.RCEN);    // M҂//
        I2C1CONbits.ACKEN = 1;      // ACKԑ//
        Buffer[i] = I2C1RCV;        // Mf[^擾//
        IdleI2C1();                 // ACh҂//
    }
    I2C1CONbits.ACKDT = 1;          // NACKݒ//
    I2C1CONbits.RCEN = 1;           // M//
    while(I2C1CONbits.RCEN);        // M҂//
    I2C1CONbits.ACKEN = 1;          // NACKԑ//
    Buffer[i] = I2C1RCV;            // Mf[^擾//
    IdleI2C1();                     // ACh҂//
    I2C1CONbits.PEN = 1;            // Xgbvo//
    while(I2C1CONbits.PEN);         // XgbvI҂//
}
/*** 1oCgMTu֐ ****/
void DataTrans(unsigned char sData){
    IFS1bits.MI2C1IF = 0;
    I2C1TRN = sData;                // f[^M//
    while(IFS1bits.MI2C1IF == 0);   // MI҂//
}
/******************************************
*  UARTM荞ݏ֐
*  64oCg荞
*******************************************/
void __attribute__((interrupt, no_auto_psv))  _U2RXInterrupt(void)
{
    char  data;
    /* MG[`FbN */
    IFS1bits.U2RXIF = 0;            // 荞݃tONA
    if(U2STAbits.OERR || U2STAbits.FERR) {
        data = U2RXREG;;
        U2STA &= 0xFFF0;            // G[tONA
        U2MODE = 0;                 // UART1~
        U2MODE = 0x8808;            // UART1L
        U2STA =  0x0400;            // TX Enable       
        Index = 0;
    }
    else {                          // M̏ꍇ
        if(Index < 32){
            data = U2RXREG;         // f[^o 
            RcvBuf[Index++] = data; // obt@ɕۑ        
            if(data == '\n'){       // sM̏ꍇ
                RcvBuf[Index--] = 0;// C}[Nɒu
                rFlag = 1;          // MtOZbg
                Index = 0;          // |C^Zbg
            }
        }
        else
            data = U2RXREG;         // ǂݔ΂          
    }
}
 /*****************************************
 * UART MsTu֐
 ******************************************/
void Send(char Data){
    while(!U2STAbits.TRMT);          // MfB[҂
    U2TXREG = Data;                  // Ms

}
/****************************************
 *  񑗐M֐
 ***************************************/
void SendStr(char *str){
    while(*str != 0){               // Ō܂ŌJԂ
        Send(*str++);               // 1M       
    }
}
/***************************************************
 * 10usecx֐@^C}2gp Fosc=16MHz
 ***************************************************/
void Delay10(unsigned int t){
    IFS0bits.T2IF = 0;              // 荞݃tONA
    PR2 = 160;                      // 10usecݒ
    T2CON = 0x8000;                 // ^C}4X^[g@vXP[ 1/1
    while (t--) {                   // JԂ
        while (!IFS0bits.T2IF);     // ҂
        IFS0bits.T2IF = 0;          // 荞݃tONA
    }
}
/**************************************
 *  l當ɕϊ
 * ***********************************/
void itostring(char digit, unsigned int data, char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/**************************************
 *  l當ɕϊ
 * ***********************************/
void ltostring(char digit, unsigned long data, char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, float data, char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                     //肩
        buffer += seisu+shousu+1;		//Š{_
    else                                //Ȃ̂Ƃ
        buffer += seisu + shousu;		//Š̂
    buffer--;                           //z|C^-1
    for(i=0; i<shousu; i++)             //𐮐ɕϊ
        data = data * 10;               //PO{
    /// dumyI[o[t[ƕϊs(WE)
    dumy = (long) (data + 0.5);			//ľܓĐɕϊ
    for(i=shousu; i>0; i--)	{           //JԂ
        *buffer =(dumy % 10)+'0';		//l𕶎ɕϊi[
        buffer--;                       //i[ꏊʂʂ
        dumy /= 10;                     //̌
    }
    if(shousu != 0) {                   //0Ȃ珬_Ȃ
        *buffer = '.';                  //_i[
        buffer--;                       //|C^-1
    }
    for(i=seisu; i>0; i--) {			//JԂ
        *buffer = (dumy % 10)+'0';		//l𕶎ɕϊi[
        buffer--;                       //|C^-1
        dumy /= 10;                     //̌
    }
    i = 0;                              // uLO
    buffer++;
    while((i<seisu-1)&&(*buffer == '0')){ // ʌ0̊
        *buffer = ' ';                  // uNɕϊ
        buffer++;
        i++;
    }
}


